.286
local
jumps

.MODEL COMPACT

equip_bits	equ	10h
dsk_recal_stat	equ	3Eh
dsk_motor_stat	equ	3Fh
dsk_motor_tmr	equ	40h
dsk_ret_code	equ	41h
dsk_status_1	equ	42h
dsk_status_2	equ	43h
dsk_status_4	equ	45h
dsk_data_rate	equ	8Bh
hdsk_options	equ	8Fh
hdsk0_media_st	equ	90h
hdsk0_cylinder	equ	94h

.CODE

label		addr_table		; Data table (indexed access)
		dw	offset reset_entry		; 0	0
		dw	offset status_entry		; 1	1
		dw	offset read_entry		; 2	2
		dw	offset write_entry		; 3	3
		dw	offset verify_entry		; 4	4
		dw	offset format_entry		; 5	5
		dw	offset param_entry		; 8	6
		dw	offset read_long_entry		; 0ah	7
		dw	offset seek_cyl_entry		; 0ch	8
		dw	offset read_id_entry		; 10h	9
		dw	offset get_type_entry		; 15h	10
		dw	offset change_line_entry	; 16h	11
		dw	offset set_type_entry		; 17h	12
		dw	offset set_media_entry		; 18h	13

		PUBLIC	C int_40h_entry
int_40h_entry:
		sti
		cld
		push	ax cx dx bx bp si di ds es bp
		mov	bp, sp
		push	ax
		mov	al, ah
		cmp	al, 18h
		ja	inv_command
		cmp	al, 15h
		jb	loc_vfy
		sub	al, 15h - 10
		jmp	l_tbl_entry
loc_vfy:	cmp	al, 5
		jbe	l_tbl_entry
		sub	al, 2
		cmp	al, 6
		jz	l_tbl_entry
		dec	al
		cmp	al, 7
		jz	l_tbl_entry
		dec	al
		cmp	al, 8
		jz	l_tbl_entry
		sub	al, 3
		cmp	al, 9
		jnz	inv_command
l_tbl_entry:	push	40h
		pop	ds
		cbw
		mov	di, ax
		pop	ax
		shl	di, 1
		jmp	word ptr cs:addr_table[di] ; 12 entries
exit_int40h:
		mov	[bp+13h], ah
		mov	ax, 201h
		jc	loc_5
		and	word ptr [bp+18h], NOT 1
		dec	ax
loc_5:		or	[bp+18h], ax
		pop	bp es ds di si bp bx dx cx ax
		iret
inv_command:	pop	ax
		mov	ax, 0100h	; invalid command code
		jmp	loc_5

;===== Indexed Entry Point

reset_entry:
		call	D_spec_param
		mov	ds:dsk_ret_code, ah
		mov	al, ah
		lahf
		push	ax
		push	ds
		xor	si, si
		mov	ds, si
		lds	si, dword ptr ds:78h ; disk para
		mov	cl, [si+2]
		pop	ds
		mov	ds:dsk_motor_tmr, cl
		pop	ax
		sahf
		mov	ah, al
		jmp	exit_int40h

;===== Indexed Entry Point

status_entry:
		mov	ah, ds:dsk_ret_code
		or	ah, ah
		jz	loc_9
		stc
loc_9:		jmp	exit_int40h

;===== Indexed Entry Point

get_type_entry:
		cmp	dl, 1
		jbe	loc_11
		mov	ah, 1
		stc
		mov	ds:dsk_ret_code, ah
		jmp	loc_15
loc_11:		mov	bx, hdsk0_media_st
		xor	dh, dh
		add	bx, dx
		mov	bl, [bx]
		cmp	bl, 0
		jne	loc_12
		xor	ah, ah
		jmp	loc_14
loc_12:		test	byte ptr ds:hdsk_options, 1
		jz	loc_13
		and	bl, 7
		cmp	bl, 0
		je	loc_13
		cmp	bl, 3
		je	loc_13
		mov	ah, 2
		jmp	loc_14
loc_13:		mov	ah, 1
loc_14:		clc
		mov	byte ptr ds:dsk_ret_code, 0
loc_15:		jmp	exit_int40h

;===== Indexed Entry Point

set_type_entry:
		xor	ah, ah
		cmp	dl, 1
		jbe	loc_19
loc_17:		mov	ah, 1
loc_18:		mov	ds:dsk_ret_code, ah
		stc
		jmp	loc_26
loc_19:		test	byte ptr ds:hdsk_options, 1
		jnz	loc_20
		xor	ah, ah
		mov	ds:dsk_ret_code, ah
		jmp	loc_26
loc_20:		cmp	al, 0
		je	loc_17
		cmp	al, 4
		ja	loc_17
		mov	bx, hdsk0_media_st
		xor	dh, dh
		add	bx, dx
		cmp	al, 1
		jne	loc_21
		and	byte ptr [bx], 20h
		or	byte ptr [bx], 93h
		mov	byte ptr ds:dsk_ret_code, 0
		jmp	loc_25
loc_21:		mov	cx, ax
		push	bx
		call	D_on_off_motor
		pop	si
		push	si
		call	D_is_ready
		pop	bx
		cmp	ah, 80h
		jne	loc_22
		cmp	byte ptr [bx], 97h
		je	loc_18
		mov	byte ptr [bx], 61h
		jmp	loc_18
loc_22:		cmp	cl, 4
		jne	loc_23
		mov	byte ptr [bx], 97h
		jmp	loc_25
loc_23:		cmp	cl, 2
		jne	loc_24
		and	byte ptr [bx], 20h
		or	byte ptr [bx], 54h
		jmp	loc_25
loc_24:		mov	byte ptr [bx], 15h
loc_25:		or	ah, ah
		jnz	loc_18
		mov	byte ptr ds:dsk_ret_code, 0
loc_26:		jmp	exit_int40h

;===== Indexed Entry Point

seek_cyl_entry:
		cmp	dl, 1
		jbe	loc_s61
		mov	ah, 1
loc_s60:	mov	ds:dsk_ret_code, ah
		stc
		jmp	exit_int40h
loc_s61:	mov	si, hdsk0_media_st
		push	dx
		xor	dh, dh
		add	si, dx
		pop	dx
		cmp	byte ptr [si], 0
		jne	loc_s62
		mov	ah, 80h
		jmp	loc_s60
loc_s62:	mov	di, dsk_motor_stat
		or	byte ptr [di], 80h
		call	D_on_off_motor
		call	D_seek_track
		jnc	loc_s67
loc_s66:	mov	bx, dsk_status_1
		mov	cx, 7
		push	ax
		call	D_get_result_codes
		pop	ax
loc_s67:	mov	ds:dsk_ret_code, ah
		call	load_disk_param
		mov	ah, ds:dsk_ret_code
		or	ah, ah
		jz	loc_s69
		stc
loc_s69:	jmp	exit_int40h

;===== Indexed Entry Point

read_id_entry:
		push	bx
		mov	di, dsk_motor_stat
		or	byte ptr [di], 80h
		call	D_on_off_motor
		mov	dh, dl
		mov	dl, 4Ah
		mov	si, dx
		mov	ch, 2
		and	byte ptr ds:dsk_recal_stat, 7Fh
		call	D_write_CH_params
		jc	loc_s68
		mov	bx, dsk_status_1
		mov	cx, 7
		call	D_get_result_codes
		jc	loc_s68
		call	error_code
loc_s68:	mov	ds:dsk_ret_code, ah
		pop	di
		test	ah, ah
		jnz	exit_int40h
		mov	si, dsk_status_1 + 3
		movsw
		movsw
		jmp	exit_int40h

;===== Indexed Entry Point

change_line_entry:
		cmp	dl, 1
		jbe	loc_29
		mov	ah, 1
loc_28:		stc
		jmp	loc_33
loc_29:		xor	dh, dh
		mov	bx, hdsk0_media_st
		add	bx, dx
		cmp	byte ptr [bx], 0
		jne	loc_30
		mov	ah, 80h
		jmp	loc_28
loc_30:		mov	ah, [bx]
		and	ah, 7
		cmp	ah, 0
		je	loc_31
		cmp	ah, 3
		jne	loc_32
loc_31:		mov	ah, 6
		stc
		jmp	loc_33
loc_32:		call	D_on_off_motor
		mov	dx, 3F7h
		in	al, dx		; port 3F7h, dsk0 status C
		shl	al, 1
		jc	loc_31
		xor	ah, ah
loc_33:		mov	ds:dsk_ret_code, ah
		push	ax
		push	si
		push	ds
		mov	si, 0
		mov	ds, si
		lds	si, dword ptr ds:78h ; disk para
		mov	al, [si+2]
		pop	ds
		mov	ds:dsk_motor_tmr, al
		pop	si
		pop	ax
		jmp	exit_int40h

;===== Indexed Entry Point

read_entry:
write_entry:
verify_entry:
read_long_entry:
		cmp	dl, 1
		jbe	loc_36
		mov	ah, 1
loc_35:		mov	ds:dsk_ret_code, ah
		xor	al, al
		stc
		jmp	loc_58
loc_36:		mov	si, hdsk0_media_st
		push	dx
		xor	dh, dh
		add	si, dx
		cmp	byte ptr [si], 0
		pop	dx
		jnz	loc_39
		push	ax
		push	dx
		call	floppy_type
		pop	dx
		jz	loc_38
		pop	ax
loc_37:		mov	ah, 80h
		jmp	loc_35
loc_38:		or	al, al
		pop	ax
		jz	loc_37
		mov	byte ptr [si], 2
loc_39:		mov	di, dsk_motor_stat
		and	byte ptr [di], 7Fh
		cmp	ah, 3
		jne	loc_40
		or	byte ptr [di], 80h
loc_40:		push	si
		call	floppy_type
		jnz	loc_41
		cmp	al, 1
		jne	loc_41
		push	cx
		mov	ch, ds:dsk_recal_stat
		mov	cl, dl
		inc	cl
		shr	ch, cl
		pop	cx
		jc	loc_41
		mov	byte ptr [si], 80h
loc_41:		call	D_on_off_motor
		call	D_is_ready
		pop	si
		jnc	loc_43
loc_42:		call	load_disk_param
		jmp	loc_35
loc_43:		test	byte ptr [si], 10h
		jnz	loc_44
		call	D_read_BI
		jc	loc_42
		jmp	loc_45
loc_44:		call	set_xfer_rate
loc_45:		mov	ax, [bp+12h]
		xor	ah, ah
		push	ds
		xor	si, si
		mov	ds, si
		lds	si, dword ptr ds:78h ; disk para
		mov	cl, [si+3]
		shl	al, cl
		mov	cl, 80h
		mul	cl
		pop	ds
		dec	ax
		mov	cx, ax
		mov	ax, [bp+12h]
		cmp	ah, 0ah
		jnz	loc_v
		mov	cx, 3fffh	; 16k length
loc_v:		call	vfy_DMA_bound
		jnc	loc_46
		mov	cx, [bp+10h]
		jmp	loc_42
loc_46:		mov	ax, [bp+12h]
		cmp	ah, 2
		jne	loc_47
		mov	ah, 46h		; DMA write to memory
		jmp	loc_49
loc_47:		cmp	ah, 3
		jne	loc_48
		mov	ah, 4Ah		; DMA read from memory
		jmp	loc_49
loc_48:		cmp	ah, 4
		jne	loc_4x
		mov	ah, 42h		; DMA verify against memory
		jmp	loc_49
loc_4x:		cmp	ah, 0ah
		jne	loc_49
		mov	ah, 46h		; DMA write to memory
		jmp	loc_49
loc_49:		call	init_DMA
		mov	ax, [bp+12h]
		mov	cx, [bp+10h]
		call	D_seek_track
		jnc	loc_51
loc_50:		mov	al, 0
		push	ax
		mov	bx, dsk_status_1
		mov	cx, 7
		call	D_get_result_codes
		pop	ax
		jmp	loc_56
loc_51:		push	ds
		xor	si, si
		mov	ds, si
		lds	si, dword ptr ds:78h ; disk para
		mov	ah, [si+3]
		mov	al, cl
		mov	[bp], ax
		mov	bx, [si+4]
		mov	cl, [si+6]
		pop	ds
		mov	si, hdsk0_media_st
		xor	dh, dh
		add	si, dx
		mov	dl, [si]
		and	dl, 7
		mov	dh, 1Bh
		cmp	dl, 5
		je	loc_52
		cmp	byte ptr [si], 17h
		je	loc_52
		mov	dh, 23h
		cmp	dl, 4
		je	loc_52
		mov	dh, 2Ah
loc_52:		mov	bh, dh
		mov	dx, [bp+0Eh]
		push	cx
		mov	cl, ch
		mov	ch, dh
		mov	di, cx
		shl	dh, 2
		or	dh, dl
		mov	ax, [bp+12h]
		mov	dl, 0C5h	; 8272 write command
		cmp	ah, 3
		jz	loc_53
		mov	dl, 0E6h	; 8272 read command
		cmp	ah, 0ah
		jnz	loc_53
		mov	dl, 042h	; 8272 read raw
		mov	word ptr [bp], 0700h ; 16k sector
		mov	bx, 7ffh
loc_53:		mov	si, dx
		pop	cx
		mov	ch, 9
		and	byte ptr ds:dsk_recal_stat, 7Fh
		call	D_write_CH_params
		jc	loc_50
		mov	bx, dsk_status_1
		mov	cx, 7
		call	D_get_result_codes
		jnc	loc_55
		mov	al, 0
		jmp	loc_56
loc_55:		call	error_code
loc_56:		mov	ds:dsk_ret_code, ah
		mov	dx, [bp+0Eh]
		mov	bx, [bp+0Ch]
		mov	cx, [bp+10h]
		call	load_disk_param
		or	al, al
		jz	loc_57
		sub	bl, cl
		mov	al, bl
loc_57:		mov	ah, ds:dsk_ret_code
		or	ah, ah
		jz	loc_58
		stc
loc_58:		mov	[bp+12h], al
		jmp	exit_int40h

;===== Indexed Entry Point

format_entry:
		cmp	dl, 1
		jbe	loc_61
		mov	ah, 1
loc_60:		mov	ds:dsk_ret_code, ah
		stc
		jmp	exit_int40h
loc_61:		mov	si, hdsk0_media_st
		push	dx
		xor	dh, dh
		add	si, dx
		pop	dx
		cmp	byte ptr [si], 0
		jne	loc_62
		mov	ah, 80h
		jmp	loc_60
loc_62:		mov	di, dsk_motor_stat
		or	byte ptr [di], 80h
		call	D_on_off_motor
		call	D_is_ready
		jnc	loc_64
loc_63:		call	load_disk_param
		jmp	loc_60
loc_64:		call	set_xfer_rate
		push	ds
		xor	si, si
		mov	ds, si
		lds	si, dword ptr ds:78h ; disk para
		mov	al, [si+4]
		pop	ds
		xor	ah, ah
		mov	cl, 4
		mul	cl
		mov	cx, ax
		dec	cx
		call	vfy_DMA_bound
		jnc	loc_65
		jmp	loc_63
loc_65:		mov	ah, 4Ah
		call	init_DMA
		mov	cx, [bp+10h]
		call	D_seek_track
		jnc	loc_67
loc_66:		mov	bx, dsk_status_1
		mov	cx, 7
		push	ax
		call	D_get_result_codes
		pop	ax
		jmp	loc_68
loc_67:		shl	dh, 2
		or	dh, dl
		mov	dl, 0CDh
		push	ds
		xor	si, si
		mov	ds, si
		lds	si, dword ptr ds:78h ; disk para
		push	ax
		mov	ax, [si+7]
		mov	[bp], ax
		pop	ax
		mov	di, [si+3]
		pop	ds
		mov	si, dx
		mov	ch, 6
		and	byte ptr ds:dsk_recal_stat, 7Fh
		call	D_write_CH_params
		jc	loc_66
		mov	bx, dsk_status_1
		mov	cx, 7
		call	D_get_result_codes
		jc	loc_68
		call	error_code
loc_68:		mov	ds:dsk_ret_code, ah
		call	load_disk_param
		mov	ah, ds:dsk_ret_code
		or	ah, ah
		jz	loc_69
		stc
loc_69:		jmp	exit_int40h

;===== Indexed Entry Point

param_entry:
		cmp	dl, 80h
		jb	loc_71
		mov	ah, 1
		mov	ds:dsk_ret_code, ah
		stc
		jmp	exit_int40h
loc_71:		xor	di, di
		xor	si, si
		xor	dh, dh
		mov	al, ds:equip_bits
		and	al, 0C1h
		mov	di, 2
		cmp	al, 41h
		je	loc_72
		dec	di
		cmp	al, 1
		je	loc_72
		jmp	loc_80
loc_72:		cmp	dl, 1
		jbe	loc_73
		jmp	loc_81
loc_73:		mov	al, 0Eh
		call	read_n_vfy_CMOS
		test	al, 0C0h
		jnz	loc_76
		mov	al, 10h
		call	read_n_vfy_CMOS
		or	dl, dl
		jnz	loc_74
		mov	cl, 4
		shr	al, cl
loc_74:		and	al, 0Fh
		jz	loc_76
		cmp	al, 4
		ja	loc_76
		xor	ah, ah
		mov	si, ax
		mov	dh, al
		mov	bx, hdsk0_media_st
		add	bl, dl
		mov	al, [bx]
		test	al, 10h
		jnz	loc_78
		cmp	si, 1
		mov	al, 80h
		jz	loc_75
		cmp	si, 2
		mov	al, 2
		jz	loc_75
		cmp	si, 3
		mov	al, 97h
		jz	loc_75
		mov	al, 7
loc_75:		mov	[bx], al
		jmp	loc_78
loc_76:		mov	bx, hdsk0_media_st
		add	bl, dl
		mov	al, [bx]
		test	al, 10h
		jz	loc_80
		mov	ah, al
		and	al, 0C0h
		cmp	al, 80h
		mov	si, 2
		jnz	loc_77
		test	ah, 4
		mov	si, 1
		jz	loc_78
		mov	si, 4
loc_77:		cmp	ah, 17h
		jne	loc_78
		mov	si, types
loc_78:		dec	si
		add	si, si
		mov	ax, cs:[dsk_type + si]
		mov	bx, di
		mov	byte ptr [bp+0Fh], 1
		push	cs
		pop	es
		mov	di, cs:[d_table + si]
		mov	es:[di+4], al
loc_79:		mov	[bp+0Eh], bl
		mov	[bp+10h], ax
		mov	[bp+0Ch], dh
		mov	byte ptr [bp+0Dh], 0
		mov	[bp+2], es
		mov	[bp+6], di
		mov	ds:dsk_ret_code, ah
		xor	ax, ax
		mov	[bp+12h], al
		jmp	exit_int40h
loc_80:		xor	di, di
loc_81:		xor	dh, dh
		xor	ax, ax
		mov	es, ax
		mov	byte ptr [bp+0Fh], 0
		mov	bx, di
		jmp	loc_79

dsk_type	label		; Data table (indexed access)
		dw	4F09h
		dw	4f0Fh
		dw	4f09h
		dw	4f12h
types	equ	($-dsk_type)/2

d_table		label		; Data table (indexed access)
		dw offset tab_1
		dw offset tab_2
		dw offset tab_3
		dw offset tab_4

tab_1	db 0DFh, 2, 25h, 2, 09h, 2Ah, 0FFh, 50h, 0F6h, 0Fh, 8 ;40
tab_2	db 0DFh, 2, 25h, 2, 0Fh, 1Bh, 0FFh, 54h, 0F6h, 0Fh, 8 ;80
tab_3	db 0DFh, 2, 25h, 2, 09h, 2Ah, 0FFh, 50h, 0F6h, 0Fh, 8 ;80
tab_4	db 0AFh, 2, 25h, 2, 12h, 1Bh, 0FFh, 6Ch, 0F6h, 0Fh, 8 ;80
tab_5	db 0DFh, 2, 25h, 2, 09h, 2Ah, 0FFh, 50h, 0F6h, 0Fh, 8 ;40
tab_6	db 0AFh, 2, 25h, 2, 24h, 1Bh, 0FFh, 50h, 0F6h, 0Fh, 8 ;80
tab_7	db 0AFh, 2, 25h, 3, 08h, 35h, 0FFh, 74h, 0F6h, 0Fh, 8 ;80

;===== Indexed Entry Point

set_media_entry:
		cmp	dl, 1
		jbe	loc_84
		mov	ah, 1
loc_83:		stc
		jmp	exit_int40h
loc_84:		test	byte ptr ds:hdsk_options, 1
		jnz	loc_85
		mov	ah, 80h
		jmp	loc_83
loc_85:		call	floppy_type
		jz	loc_87
loc_86:		mov	ah, 0Ch
		jmp	loc_83
loc_87:		mov	dx, [bp+0Eh]
		mov	bx, hdsk0_media_st
		xor	dh, dh
		add	bx, dx
		mov	cx, [bp+10h]
		cmp	al, 1
		jne	loc_89
		mov	si, offset tab_1
		mov	al, 93h
		cmp	cx, 4F09h
		je	loc_88
		mov	ah, [bx]
		and	ah, 20h
		or	al, ah
		cmp	cx, 2709h
		je	loc_88
		cmp	cx, 2708h
		mov	si, offset tab_7
		jnz	loc_86
loc_88:		mov	dh, 2
		jmp	loc_97
loc_89:		cmp	al, 3
		je	loc_90
		cmp	al, 4
		je	loc_91
		cmp	al, 2
		jne	loc_86
		cmp	cx, 4F0Fh
		je	loc_92
		cmp	cx, 2709h
		je	loc_92
		cmp	cx, 2708h
		je	loc_92
loc_90:		cmp	cx, 4F09h
		jne	loc_86
		jmp	loc_92
loc_91:		cmp	cx, 4F12h
		jne	loc_90
loc_92:		push	ax
		push	bx
		call	D_on_off_motor
		pop	si
		push	si
		call	D_is_ready
		pop	bx
		cmp	ah, 80h
		jne	loc_94
		mov	ds:dsk_ret_code, ah
		pop	ax
		cmp	al, 3
		je	loc_93
		and	byte ptr [bx], 0EFh
loc_93:		jmp	loc_83
loc_94:		pop	ax
		mov	cx, [bp+10h]
		cmp	cx, 4F09h
		jne	loc_96
		cmp	al, 2
		jne	loc_95
		mov	al, 54h
		mov	si, offset tab_5
		mov	dh, 1
		jmp	loc_97
loc_95:		mov	al, 97h
		mov	si, offset tab_3
		mov	dh, 2
		jmp	loc_97
loc_96:		cmp	cx, 4F12h
		mov	al, 17h
		mov	si, offset tab_4
		mov	dh, 0
		jz	loc_97
		cmp	cx, 4F0Fh
		mov	al, 15h
		mov	si, offset tab_2
		jz	loc_97
		cmp	cx, 2709h
		mov	al, 74h
		mov	si, offset tab_5
		mov	dh, 1
		jz	loc_97
		mov	si, offset tab_6
loc_97:		mov	cs:[si+4], cl
		mov	[bx], al
		push	es ds si di cx
		xor	cx, cx
		mov	ds, cx
		les	di, ds:[78h]
		mov	cx, cs
		mov	ds, cx
		mov	cx, 11
		rep	movsb
		pop	cx di si ds es
		push	dx
		call	D_data_transfer_rate
		pop	dx
		mov	al, [bx]
		mov	ds:dsk_data_rate, al
		mov	[bp+6], si
		mov	[bp+2], cs
		mov	byte ptr ds:dsk_ret_code, 0
		xor	ah, ah
		jmp	exit_int40h

;		SUBROUTINE

D_spec_param	proc	near
		and	byte ptr ds:dsk_recal_stat, 0F0h
		call	D_dor_motor
		jc	loc_101
		mov	dx, 3F4h
		in	al, dx		; port 3F4h, dsk0 cntrlr status
		test	al, 80h
		jz	loc_98
		test	al, 40h
		jz	loc_100
loc_98:		call	D_dor_motor
		mov	dx, 3F4h
		in	al, dx		; port 3F4h, dsk0 cntrlr status
		test	al, 80h
		jz	loc_99
		test	al, 40h
		jz	loc_100
loc_99:		mov	ah, 20h
		stc
		jmp	loc_101
loc_100:	mov	ah, 8
		call	D_write_data
		jc	loc_101
		call	D_command_status
		jc	loc_101
		mov	ds:dsk_status_1, al
		push	ax
		call	D_command_status
		mov	ds:dsk_status_2, al
		pop	cx
		jc	loc_101
		and	cl, 0C0h
		cmp	cl, 0C0h
		jne	loc_99
		xor	ah, ah
loc_101:	jc	ret_102
		push	ds
		xor	bx, bx
		mov	ds, bx
		lds	bx, dword ptr ds:78h ; disk para
		mov	al, 3
		mov	ah, [bx+0]
		mov	si, ax
		mov	al, [bx+1]
		mov	di, ax
		mov	ch, 3
		pop	ds
		or	byte ptr ds:dsk_recal_stat, 80h
		call	D_write_CH_params
		jc	ret_102
		xor	ah, ah
ret_102:	retn
D_spec_param	endp

;		SUBROUTINE

D_recalibration proc	near
		push	cx
		push	dx
		mov	dh, dl
		mov	dl, 7
		mov	si, dx
		mov	ch, 2
		and	byte ptr ds:dsk_recal_stat, 7Fh
		call	D_write_CH_params
		jc	loc_103
		mov	si, 8
		mov	ch, 1
		or	byte ptr ds:dsk_recal_stat, 80h
		call	D_write_CH_params
		jc	loc_103
		mov	bx, dsk_status_1
		mov	cx, 2
		call	D_get_result_codes
		jc	loc_103
		mov	bx, dsk_status_1
		mov	ah, 40h
		mov	dl, [bx]
		and	dl, 60h
		cmp	dl, 60h
		stc
		jz	loc_103
		pop	dx
		push	dx
		xor	dh, dh
		mov	bx, 94h
		add	bx, dx
		mov	byte ptr [bx], 0
		mov	cl, dl
		mov	dl, 1
		shl	dl, cl
		or	ds:dsk_recal_stat, dl
		xor	ah, ah
loc_103:	mov	ds:dsk_ret_code, ah
		pop	dx
		pop	cx
		retn
D_recalibration endp

;		SUBROUTINE

D_seek_track	proc	near
		push	bx
		push	cx
		mov	ah, ds:dsk_recal_stat
		mov	cl, dl
		inc	cl
		shr	ah, cl
		jc	loc_104
		call	D_recalibration
		jnc	loc_104
		call	D_recalibration
		jnc	loc_104
		jmp	loc_113
loc_104:	mov	bx, hdsk0_cylinder
		xor	dh, dh
		add	bx, dx
		mov	si, hdsk0_media_st
		add	si, dx
		mov	dl, ch
		test	byte ptr [si], 20h
		jz	loc_105
		add	dl, dl
loc_105:	cmp	[bx], dl
		mov	dx, [bp+0Eh]
		jnz	loc_106
		cmp	byte ptr ds:dsk_ret_code, 40h
		je	loc_106
		xor	ah, ah
		jmp	loc_113
loc_106:	shl	dh, 2
		or	dh, dl
		mov	dl, 0Fh		; "seek"
		mov	si, dx
		mov	cl, ch
		mov	dx, [bp+0Eh]
		mov	bx, hdsk0_media_st
		xor	dh, dh
		add	bx, dx
		test	byte ptr [bx], 20h
		jz	loc_107
		add	cl, cl
loc_107:	mov	di, cx		; cylinder
		mov	ch, 3
		and	byte ptr ds:dsk_recal_stat, 7Fh
		call	D_write_CH_params
		jnc	loc_108
		jmp	loc_112
loc_108:	mov	si, 8		; get status
		mov	ch, 1
		or	byte ptr ds:dsk_recal_stat, 80h
		call	D_write_CH_params
		jc	loc_112
		mov	bx, dsk_status_1
		mov	cx, 2
		call	D_get_result_codes
		jc	loc_112
		mov	bx, dsk_status_1
		mov	ah, 40h
		mov	dl, [bx]
		and	dl, 60h
		cmp	dl, 60h
		stc
		jz	loc_112
		mov	dx, [bp+0Eh]
		pop	cx
		push	cx
		mov	si, hdsk0_cylinder
		xor	dh, dh
		add	si, dx
		mov	[si], ch
		mov	bx, hdsk0_media_st
		add	bx, dx
		mov	bl, [bx]
		test	bl, 20h
		jz	loc_109
		add	[si], ch
loc_109:	push	ds
		xor	si, si
		mov	ds, si
		lds	si, dword ptr ds:78h ; disk para
		mov	al, [si+9]
		pop	ds
		test	byte ptr ds:dsk_motor_stat, 80h
		jz	loc_110
		or	al, al
		jnz	loc_110
		and	bl, 7
		mov	al, 14h
		cmp	bl, 0
		je	loc_110
		cmp	bl, 3
		je	loc_110
		mov	al, 0Fh
loc_110:	or	al, al
		jz	loc_111
		mov	cx, 43h
		call	wait_refresh
		dec	al
		jmp	loc_110
loc_111:	xor	ah, ah
loc_112:	mov	ds:dsk_ret_code, ah
loc_113:	mov	dx, [bp+0Eh]
		pop	cx
		pop	bx
		retn
D_seek_track	endp

;		SUBROUTINE

D_read_BI	proc	near
		push	bx
		push	cx
		mov	dx, [bp+0Eh]
		mov	si, hdsk0_media_st
		xor	dh, dh
		add	si, dx
		mov	dh, [si]
		and	dh, 7
		jnz	loc_114
		mov	byte ptr [si], 2
loc_114:	call	floppy_type
		jnz	loc_115
		cmp	al, 3
		jne	loc_115
		mov	byte ptr [si], 97h
		call	set_xfer_rate
		xor	ah, ah
		jmp	loc_135
loc_115:	mov	dx, [bp+0Eh]
		mov	ch, 2
		call	D_seek_track
		jnc	loc_116
		jmp	loc_136
loc_116:	call	floppy_type
		jnz	loc_117
		cmp	al, 1
		jne	loc_117
		mov	byte ptr ds:dsk_data_rate, 80h
		jmp	loc_123
loc_117:	xor	dh, dh
		call	D_data_transfer_rate
		mov	byte ptr ds:dsk_data_rate, 2
		mov	cx, 5
llp_118:	push	cx
		mov	dh, dl
		mov	dl, 4Ah
		mov	si, dx
		mov	ch, 2
		and	byte ptr ds:dsk_recal_stat, 7Fh
		call	D_write_CH_params
		jc	loc_121
		mov	bx, dsk_status_1
		mov	cx, 7
		call	D_get_result_codes
		jc	loc_121
		mov	dx, [bp+0Eh]
		mov	bx, dsk_status_1
		test	byte ptr [bx], 0C0h
		jnz	loc_120
		call	floppy_type
		jnz	loc_119
		cmp	al, 4
		jne	loc_119
		mov	ah, 17h
		mov	ds:dsk_data_rate, ah
		jmp	loc_131
loc_119:	mov	ah, 15h
		mov	ds:dsk_data_rate, ah
		jmp	loc_131
loc_120:	pop	cx
		loop	llp_118
		mov	ah, 80h
		test	byte ptr [bx], 8
		jz	loc_122
		stc
		jmp	loc_135
loc_121:	pop	cx
		jmp	loc_135
loc_122:	call	floppy_type
		jnz	loc_124
		cmp	al, 4
		jne	loc_124
		mov	byte ptr ds:dsk_data_rate, 87h
loc_123:	mov	dh, 2
		call	D_data_transfer_rate
		jmp	loc_125
loc_124:	mov	dh, 1
		call	D_data_transfer_rate
		mov	byte ptr ds:dsk_data_rate, 61h
loc_125:	mov	cx, 5
llp_126:	push	cx
		mov	dh, dl
		mov	dl, 4Ah
		mov	si, dx
		mov	ch, 2
		and	byte ptr ds:dsk_recal_stat, 7Fh
		call	D_write_CH_params
		jc	loc_121
		mov	bx, dsk_status_1
		mov	cx, 7
		call	D_get_result_codes
		jc	loc_121
		mov	dx, [bp+0Eh]
		mov	bx, dsk_status_1
		test	byte ptr [bx], 0C0h
		jz	loc_128
		pop	cx
		loop	llp_126
		mov	ah, 80h
		test	byte ptr [bx], 8
		jnz	loc_127
		mov	ah, 2
loc_127:	stc
		jmp	loc_135
loc_128:	call	floppy_type
		jnz	loc_130
		cmp	al, 2
		jbe	loc_129
		mov	ah, 97h
		mov	ds:dsk_data_rate, ah
		jmp	loc_131
loc_129:	jz	loc_130
		mov	ah, 93h
		mov	ds:dsk_data_rate, ah
		jmp	loc_131
loc_130:	mov	ah, 54h
		mov	ds:dsk_data_rate, ah
loc_131:	pop	cx
		mov	dx, [bp+0Eh]
		xor	dh, dh
		mov	bx, hdsk0_media_st
		add	bx, dx
		cmp	byte ptr ds:dsk_status_4, 2
		je	loc_133
		ja	loc_132
		or	ah, 20h
loc_132:	mov	[bx], ah
		jmp	loc_134
loc_133:	and	byte ptr [bx], 20h
		or	[bx], ah
loc_134:	xor	ah, ah
loc_135:	mov	ds:dsk_ret_code, ah
loc_136:	mov	dx, [bp+0Eh]
		pop	cx
		pop	bx
		retn
D_read_BI	endp

;		SUBROUTINE

D_on_off_motor	proc	near
		push	dx
		push	cx
		cli
		mov	byte ptr ds:dsk_motor_tmr, 0FFh
		and	byte ptr ds:dsk_motor_stat, 0CFh
		mov	ch, dl
		shl	dl, 4
		or	ds:dsk_motor_stat, dl
		mov	cl, ch
		mov	dl, ds:dsk_motor_stat
		inc	cl
		shr	dl, cl
		jc	loc_139
		mov	dl, 1
		dec	cl
		shl	dl, cl
		or	ds:dsk_motor_stat, dl
		sti
		mov	al, ds:dsk_motor_stat
		ror	al, 4
		or	al, 0Ch
		mov	dx, 3F2h
		out	dx, al		; port 3F2h, dsk0 contrl output
		mov	ax, 90FDh
		int	15h		; General services, ah=func 90h
		jc	loc_140
		mov	ah, ds:dsk_motor_stat
		push	ds
		push	si
		xor	si, si
		mov	ds, si
		lds	si, dword ptr ds:78h ; disk para
		mov	al, [si+0Ah]
		pop	si
		pop	ds
		shl	ah, 1
		jnc	loc_137
		cmp	al, 8
		jae	loc_138
		mov	al, 8
		jmp	loc_138
loc_137:	cmp	al, 5
		jae	loc_138
		mov	al, 5
loc_138:	mov	cx, 208Eh
		call	wait_refresh
		dec	al
		jnz	loc_138
		jmp	loc_140
loc_139:	sti
		mov	al, ds:dsk_motor_stat
		ror	al, 4
		or	al, 0Ch
		mov	dx, 3F2h
		out	dx, al		; port 3F2h, dsk0 contrl output
loc_140:	pop	cx
		pop	dx
		retn
D_on_off_motor	endp

;		SUBROUTINE

load_disk_param proc	near
		push	ax
		push	ds
		xor	bx, bx
		mov	ds, bx
		lds	bx, dword ptr ds:78h ; disk para
		mov	ah, [bx+2]
		mov	al, [bx+4]
		inc	al
		pop	ds
		mov	bx, dsk_status_1
		cmp	ch, [bx+3]
		jne	loc_141
		cmp	dh, [bx+4]
		jne	loc_141
		mov	al, [bx+5]
loc_141:	mov	ds:dsk_motor_tmr, ah
		mov	bl, al
		pop	ax
		retn
load_disk_param endp

;		SUBROUTINE

set_xfer_rate	proc	near
		push	si
		mov	si, hdsk0_media_st
		xor	dh, dh
		add	si, dx
		mov	dh, [si]
		cmp	dh, ds:dsk_data_rate
		je	loc_142
		mov	ds:dsk_data_rate, dh
		and	dh, 0C0h
		rol	dh, 2
		call	D_data_transfer_rate
loc_142:	pop	si
		mov	dx, [bp+0Eh]
		retn
set_xfer_rate	endp

;		SUBROUTINE

D_data_transfer_rate   proc    near
		push	ax
		mov	al, dh
		mov	dx, 3F7h
		out	dx, al		; port 3F7h, dsk0 config ctrl
		pop	ax
		retn
D_data_transfer_rate   endp

;		SUBROUTINE

D_is_ready	proc	near
		push	cx
		xor	ax, ax
		test	byte ptr ds:hdsk_options, 1
		jz	loc_143
		mov	al, [si]
		and	al, 7
		jz	loc_143
		cmp	al, 3
		je	loc_143
		mov	dx, 3F7h
		in	al, dx		; port 3F7h, dsk0 status C
		shl	al, 1
		jnc	loc_144
		and	byte ptr [si], 0EFh
		call	D_spec_param
		jc	loc_144
		mov	dx, [bp+0Eh]
		mov	ch, 1
		call	D_seek_track
		jc	loc_144
		mov	ch, 0
		call	D_seek_track
		jc	loc_144
		mov	ah, 6
		mov	dx, 3F7h
		in	al, dx		; port 3F7h, dsk0 status C
		shl	al, 1
		jnc	loc_143
		mov	ah, 80h
loc_143:	or	ah, ah
		jz	loc_144
		stc
loc_144:	mov	dx, [bp+0Eh]
		pop	cx
		retn
D_is_ready	endp

;		SUBROUTINE

init_DMA	proc	near
		push	ax
		push	dx
		cli
		mov	al, ah
		out	0Ch, al		; port 0Ch, DMA-1 clr byte ptr
		jmp	short $+2
		jmp	short $+2
		out	0Bh, al		; port 0Bh, DMA-1 mode reg
		jmp	short $+2
		jmp	short $+2
		mov	al, cl
		out	5, al		; port 5, DMA-1 bas&cnt ch 2
		jmp	short $+2
		jmp	short $+2
		mov	al, ch
		out	5, al		; port 5, DMA-1 bas&cnt ch 2
		jmp	short $+2
		jmp	short $+2
		mov	al, bl
		out	4, al		; port 4, DMA-1 bas&add ch 2
		jmp	short $+2
		jmp	short $+2
		mov	al, bh
		out	4, al		; port 4, DMA-1 bas&add ch 2
		jmp	short $+2
		jmp	short $+2
		mov	ax, es
		out	81h, al		; port 81h, DMA page reg ch 2
		jmp	short $+2
		jmp	short $+2
		mov	al, 2
		out	0Ah, al		; port 0Ah, DMA-1 mask reg bit
		sti
		pop	dx
		pop	ax
		retn
init_DMA	endp

;		SUBROUTINE

vfy_DMA_bound	proc	near
		push	cx
		xor	ax, ax
		mov	cx, es
		shl	cx, 1
		rcl	al, 1
		shl	cx, 1
		rcl	al, 1
		shl	cx, 1
		rcl	al, 1
		shl	cx, 1
		rcl	al, 1
		mov	bx, [bp+0Ch]
		add	bx, cx
		adc	ax, 0
		mov	es, ax
		pop	cx
		mov	ax, cx
		add	ax, bx
		jnc	ret_145
		mov	ah, 9
ret_145:	retn
vfy_DMA_bound	endp

;		SUBROUTINE

; order is: SI-l, SI-h, DI-l, DI-h, [BP]-l, [BP]-h, BL, BH, CL
D_write_command proc	near
		mov	ax, si
		mov	ah, al
		call	D_write_data
		dec	ch
		jbe	ret_146
		mov	ax, si
		call	D_write_data
		dec	ch
		jbe	ret_146
		mov	ax, di
		mov	ah, al
		call	D_write_data
		dec	ch
		jbe	ret_146
		mov	ax, di
		call	D_write_data
		dec	ch
		jbe	ret_146
		mov	ax, [bp]
		mov	ah, al
		call	D_write_data
		dec	ch
		jbe	ret_146
		mov	ax, [bp]
		call	D_write_data
		dec	ch
		jbe	ret_146
		mov	ah, bl
		call	D_write_data
		dec	ch
		jbe	ret_146
		mov	ah, bh
		call	D_write_data
		dec	ch
		jbe	ret_146
		mov	ah, cl
		call	D_write_data
ret_146:	retn
D_write_command endp

;		SUBROUTINE

D_write_CH_params proc	  near
		test	byte ptr ds:dsk_recal_stat, 80h
		jz	loc_147
		and	byte ptr ds:dsk_recal_stat, 7Fh
		call	D_write_command
		retn
loc_147:	call	D_write_command
		jc	ret_149
		mov	ax, 9001h
		int	15h		; General services, ah=func 90h
		sti
		jc	loc_148
		call	disk_recalib
		jnc	loc_150
loc_148:	mov	ah, 80h
ret_149:	retn
loc_150:	and	byte ptr ds:dsk_recal_stat, 7Fh
		xor	ah, ah
		retn
D_write_CH_params endp

;		SUBROUTINE

D_write_data	proc	near
		push	cx
		push	dx
		mov	cx, 2
		call	wait_refresh
		mov	dx, 3F4h
		push	ax
		mov	ah, 40h
		xor	cx, cx
		call	D_controller_status
		jnc	loc_151
		jmp	loc_153
loc_151:	mov	ah, 80h
		xor	cx, cx
		call	D_test_status
		jnc	loc_152
		jmp	loc_153
loc_152:	pop	ax
		mov	dx, 3F5h
		mov	al, ah
		out	dx, al		; port 3F5h, dsk0 controlr data
		jmp	loc_154
loc_153:	pop	ax
		mov	ah, 80h
loc_154:	pop	dx
		pop	cx
		retn
D_write_data	endp

;		SUBROUTINE

D_get_result_codes proc	   near
		push	dx
llp_155:	push	cx
		call	D_command_status
		pop	cx
		jc	loc_157
		mov	[bx], al
		inc	bx
		loop	llp_155
		mov	cx, 2
		call	wait_refresh
		mov	dx, 3F4h
		in	al, dx		; port 3F4h, dsk0 cntrlr status
		test	al, 10h
		jz	loc_156
		mov	ah, 20h
		stc
		jmp	loc_157
loc_156:	xor	ah, ah
loc_157:	pop	dx
		retn
D_get_result_codes endp

;		SUBROUTINE

D_command_status proc	 near
		push	dx
		mov	cx, 2
		call	wait_refresh
		mov	dx, 3F4h
		mov	ah, 80h
		xor	cx, cx
		call	D_test_status
		jnc	loc_158
		mov	ah, 80h
		jmp	loc_160
loc_158:	in	al, dx		; port 3F4h, dsk0 cntrlr status
		test	al, 40h
		jnz	loc_159
		mov	ah, 20h
		stc
		jmp	loc_160
loc_159:	mov	dx, 3F5h
		in	al, dx		; port 3F5h, dsk0 controlr data
loc_160:	pop	dx
		retn
D_command_status endp

;		SUBROUTINE

error_code	proc	near
		mov	bx, dsk_status_1
		test	byte ptr [bx], 0C0h
		jnz	loc_161
		xor	ah, ah
		jmp	ret_168
loc_161:	test	byte ptr [bx], 40h
		jz	loc_167
		mov	ah, [bx+1]
		test	ah, 1
		jz	loc_162
		mov	ah, 2
		jmp	ret_168
loc_162:	test	ah, 2
		jz	loc_163
		mov	ah, 3
		jmp	ret_168
loc_163:	test	ah, 4
		jz	loc_164
		mov	ah, 4
		jmp	ret_168
loc_164:	test	ah, 10h
		jz	loc_165
		mov	ah, 8
		jmp	ret_168
loc_165:	test	ah, 20h
		jz	loc_166
		mov	ah, 10h
		jmp	ret_168
loc_166:	test	ah, 80h
		jz	loc_167
		mov	ah, 4
		jmp	ret_168
loc_167:	mov	ah, 20h
ret_168:	retn
error_code	endp

;		SUBROUTINE

D_dor_motor	proc	near
		cli
		and	byte ptr ds:dsk_motor_stat, 7Fh
		and	byte ptr ds:dsk_recal_stat, 7Fh
		mov	al, ds:dsk_motor_stat
		rol	al, 4
		and	al, 0FBh
		or	al, 8
		mov	dx, 3F2h
		out	dx, al		; port 3F2h, dsk0 contrl output
		mov	cx, 1
		call	wait_refresh
		or	al, 0Ch
		out	dx, al		; port 3F2h, dsk0 contrl output
		mov	ax, 9001h
		int	15h		; General services, ah=func 90h
		sti
		jc	loc_169
		call	disk_recalib
loc_169:	mov	ah, 80h
		jc	ret_170
		and	byte ptr ds:dsk_recal_stat, 7Fh
		xor	ah, ah
ret_170:	retn
D_dor_motor	endp

;		SUBROUTINE

disk_recalib	proc	near
		mov	bx, dsk_recal_stat
		xor	cx, cx
		call	wait_recalib
		jnc	ret_171
		xor	cx, cx
		call	wait_recalib
ret_171:	retn
disk_recalib	endp

;		SUBROUTINE

read_n_vfy_CMOS proc	near
		pushf
		cli
		rol	al, 1
		stc
		rcr	al, 1
		out	70h, al		; port 70h, RTC addr/enabl NMI
		jmp	short $+2
		jmp	short $+2
		in	al, 71h		; port 71h, RTC clock/RAM data
		push	ax
		mov	al, 1Ah
		rcr	al, 1
		out	70h, al		; port 70h, RTC addr/enabl NMI
		jmp	short $+2
		jmp	short $+2
		in	al, 71h		; port 71h, RTC clock/RAM data
		pop	ax
		push	cs
		call	restore_flags
		retn
read_n_vfy_CMOS endp

;		SUBROUTINE

restore_flags	proc	near
		iret
restore_flags	endp

;		SUBROUTINE

D_controller_status proc    near
		push	ax
loc_172:	in	al, dx		; port 3F4h, dsk0 cntrlr status
		test	al, ah
		jz	loc_176
loc_173:	jmp	short $+2
		in	al, 61h		; port 61h, 8255 port B, read
		test	al, 10h
		jz	loc_173
		dec	cx
		jz	loc_175
		in	al, dx		; port 3F4h, dsk0 cntrlr status
		test	al, ah
		jz	loc_176
loc_174:	jmp	short $+2
		in	al, 61h		; port 61h, 8255 port B, read
		test	al, 10h
		jnz	loc_174
		dec	cx
		jnz	loc_172
loc_175:	stc
loc_176:	pop	ax
		retn
D_controller_status  endp

;		SUBROUTINE

D_test_status	proc	near
		push	ax
loc_177:	in	al, dx		; port 3F4h, dsk0 cntrlr status
		test	al, ah
		jnz	loc_181
loc_178:	jmp	short $+2
		in	al, 61h		; port 61h, 8255 port B, read
		test	al, 10h
		jz	loc_178
		dec	cx
		jz	loc_180
		in	al, dx		; port 3F4h, dsk0 cntrlr status
		test	al, ah
		jnz	loc_181
loc_179:	jmp	short $+2
		in	al, 61h		; port 61h, 8255 port B, read
		test	al, 10h
		jnz	loc_179
		dec	cx
		jnz	loc_177
loc_180:	stc
loc_181:	pop	ax
		retn
D_test_status	endp

;		SUBROUTINE

wait_recalib	proc	near
		push	ax
loc_182:	test	byte ptr [bx], 80h
		jnz	loc_186
loc_183:	jmp	short $+2
		in	al, 61h		; port 61h, 8255 port B, read
		test	al, 10h
		jz	loc_183
		dec	cx
		jz	loc_185
		test	byte ptr [bx], 80h
		jnz	loc_186
loc_184:	jmp	short $+2
		in	al, 61h		; port 61h, 8255 port B, read
		test	al, 10h
		jnz	loc_184
		dec	cx
		jnz	loc_182
loc_185:	stc
loc_186:	pop	ax
		retn
wait_recalib	endp

;		SUBROUTINE

wait_refresh	proc	near
		push	ax
		add	cx, 2
loc_187:	jmp	short $+2
		in	al, 61h		; port 61h, 8255 port B, read
		test	al, 10h
		jz	loc_187
		dec	cx
		jz	loc_189
loc_188:	jmp	short $+2
		in	al, 61h		; port 61h, 8255 port B, read
		test	al, 10h
		jnz	loc_188
		dec	cx
		jnz	loc_187
loc_189:	pop	ax
		retn
wait_refresh	endp

;		SUBROUTINE

floppy_type	proc	near
		mov	al, 0Eh
		call	read_n_vfy_CMOS
		test	al, 0C0h
		jnz	ret_191
		mov	al, 10h
		call	read_n_vfy_CMOS
		or	dl, dl
		jnz	loc_190
		shr	al, 4
loc_190:	and	al, 0Fh
		cmp	sp, sp
ret_191:	retn
floppy_type	endp

old_0e		dd	?
int_ctrl	db	?

;		SUBROUTINE

		PUBLIC	C hook_int_0E
hook_int_0E	proc	near
		push	es
		cli
		xor	ax, ax
		mov	es, ax
		mov	ax, word ptr es:[4 * 0eh]
		mov	word ptr cs:old_0e, ax
		mov	ax, word ptr es:[4 * 0eh + 2]
		mov	word ptr cs:old_0e + 2, ax
		mov	ax, offset int_0eh
		mov	word ptr es:[4 * 0eh], ax
		mov	ax, cs
		mov	word ptr es:[4 * 0eh + 2], ax
		in	al, 21h
		mov	byte ptr cs:int_ctrl, al
		and	al, NOT 40h	; unmask irq 6
		out	21h, al
		sti
		pop	es
		ret
hook_int_0E	endp

;		SUBROUTINE

		PUBLIC	C restore_int_0E
restore_int_0E	proc	near
		push	es
		cli
		mov	al, byte ptr cs:int_ctrl
		out	21h, al
		xor	ax, ax
		mov	es, ax
		mov	ax, word ptr cs:old_0e
		mov	word ptr es:[4 * 0eh], ax
		mov	ax, word ptr cs:old_0e + 2
		mov	word ptr es:[4 * 0eh + 2], ax
		sti
		pop	es
		ret
restore_int_0E	endp

;		SUBROUTINE

int_0eh		proc	far
		push	ds ax
		push	40h
		pop	ds
		or	byte ptr ds:dsk_recal_stat, 80h
		mov	al, 20h		; reset int controller
		out	20h, al
		mov	ax, 9101h	; diskette
		int	15h
		pop	ax ds
		iret
int_0eh		endp

		end
