#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <string.h>

#include "revive.h"

extern int    int_40h_entry( void );
#pragma aux int_40h_entry "_*";

extern int
tint13( byte fn, byte trk, byte head, char *buffer,
	byte sect, byte nr );
#pragma aux   tint13 = \
	"mov  dl, Drive" \
	"pushf" \
	"call far int_40h_entry" \
	"mov  al, ah" \
	"mov  ah, 0" \
	parm [AH] [CH] [DH] [ES BX] [CL] [AL] \
	caller value [AX];

static char  *
expand_error( int err )
{
  switch ( err )
  {
    case 0x00:
      return ( "Successful completion" );
    case 0x01:
      return ( "Invalid function or invalid parameter" );
    case 0x02:
      return ( "Address mark not found" );
    case 0x03:
      return ( "Disk write-protected" );
    case 0x04:
      return ( "Sector not found/read error" );
    case 0x06:
      return ( "Disk changed" );
    case 0x08:
      return ( "DMA overrun" );
    case 0x09:
      return ( "Attempted DMA across 64K boundary" );
    case 0x0C:
      return ( "Unsupported track or invalid media" );
    case 0x10:
      return ( "Uncorrectable CRC error on read" );
    case 0x20:
      return ( "Controller failure" );
    case 0x40:
      return ( "Seek failed" );
    case 0x80:
      return ( "Timeout" );
    default:
      return ( "Unknown error" );
  }
}

int
int13( int fn,... )
/* int fn,int trk,int head,char *buffer */
{
  int		code;
  int		trk, head, sect, nr;
  char	       *buffer;
  va_list	ap;
  va_start( ap, fn );

  switch ( fn )
  {
    case RESET:
      sprintf( line, "%%c0e %-34s", "RESET" );
      sput( 2, END_LINE - 1, line );
      code = tint13( fn, 0, 0, NULL, 0, 0 );
      break;
    case STATUS:
      sprintf( line, "%%c0e %-34s", "STATUS" );
      sput( 2, END_LINE - 1, line );
      code = tint13( fn, 0, 0, NULL, 1, 0 );
      break;
    case SET_MEDIA:
      sprintf( line, "%%c0e %-34s", "SET_MEDIA" );
      sput( 2, END_LINE - 1, line );
      trk = va_arg( ap, int );
      sect = va_arg( ap, int );
      code = tint13( fn, trk - 1, 0, NULL, sect, 0 );
      break;
    case SEEK_CYL:
      sprintf( line, "%%c0e %-34s", "SEEK_CYL" );
      sput( 2, END_LINE - 1, line );
      trk = va_arg( ap, int );
      sprintf( line, "%%c02Trk:%d", trk );
      sput( 13, END_LINE - 1, line );
      code = tint13( fn, trk, 0, NULL, 0, 0 );
      break;
    case READ_ID:
      sprintf( line, "%%c0e %-34s", "READ_ID" );
      sput( 2, END_LINE - 1, line );
      buffer = va_arg( ap, char * );
      code = tint13( fn, 0, 0, buffer, 0, 0 );
      break;
    case READ:
      sprintf( line, "%%c0e %-34s", "READ" );
      goto wrt;
    case VERIFY:
      sprintf( line, "%%c0e %-34s", "VERIFY" );
      goto wrt;
    case WRITE:
      sprintf( line, "%%c0e %-34s", "WRITE" );
  wrt:
      sput( 2, END_LINE - 1, line );
      trk = va_arg( ap, int );
      head = va_arg( ap, int );
      buffer = va_arg( ap, char * );
      sect = va_arg( ap, int );
      nr = va_arg( ap, int );
      mark_active( trk, head, NONE );
      sprintf( line, "%%c02Trk:%d Hd:%d Sect:%d", trk, head, sect );
      if ( nr - 1 )
	sprintf( line + strlen( line ), "-%d", sect + nr - 1 );
      sput( 13, END_LINE - 1, line );
      code = tint13( fn, trk, head, buffer, sect, nr );
      break;
    case READ_TRACK:
      sprintf( line, "%%c0e %-34s", "READTRK" );
      goto fmt;
    case FORMAT:
      sprintf( line, "%%c0e %-34s", "FORMAT" );
  fmt:
      sput( 2, END_LINE - 1, line );
      trk = va_arg( ap, int );
      head = va_arg( ap, int );
      buffer = va_arg( ap, char * );
      sect = va_arg( ap, int );
      nr = va_arg( ap, int );
      mark_active( trk, head, NONE );
      sprintf( line, "%%c02Trk:%d Hd:%d Sect:1-%d", trk, head, Boot->Sectors );
      sput( 13, END_LINE - 1, line );
      code = tint13( fn, trk, head, buffer, 1, nr );
      break;
  }
  sprintf( line, "%%c0f%-43s", expand_error( code ) );
  sput( 37, END_LINE - 1, line );
  return code;
}
