.286
locals
jumps

.MODEL COMPACT, C

.DATA

video_mode	db	?
video_page	db	?
cursor_pos	dw	?
cursor_shape	dw	?
video_data	dw	80*25 dup (?)
src_shift	db	?

.CODE

		PUBLIC	boot_start
label		boot_start

omem		equ	7c00h
off		equ	offset boot_start - omem
offd		equ	omem + SIZE DPT + offset boot_begin - boot_start

		jmp	short boot_begin
		nop

m_Msdos50	db	'MSDOS5.0'
SectSiz		dw	200h		;+0bH bytes per sector
ClustSiz	db	1		;+0dH sectors per cluster
ResSecs		dw	1		;+0eH reserved sectors (before FAT)
FatCnt		db	2		;+10H number of FATs
RootSiz		dw	0e0h		;+11H maximum root directory entries
TotSecs		dw	0B40h		;+13H total number of sectors
Media		db	0F0h		;+15H media descriptor
FatSize		dw	9		;+16H number of sectors in one FAT
Sectors		dw	12h		;+18H sectors per track
HeadCnt		dw	2		;+1aH read/write heads
HidSectL	dw	0		;+1cH number of hidden sectors L
HidSectH	dw	0		;+1eH number of hidden sectors H
LogSectL	dw	0		;+20H number of logical sectors L
LogSectH	dw	0		;+22H number of logical sectors H
B_Drive		db	0		;+24H
B_Head		db	0		;+25H
		db	29h
		db	0F3h
		db	15h
		db	6Ah
		db	3Fh
m_NoNameFat12	db	'NO NAME    FAT12   '

DPT		struc
DPT_00h		db	?	; step rate & head unload time
DPT_01h		db	?	; head load time & DMA mode (always 0)
DPT_02h		db	?	; delay until motor turned off
DPT_03h		db	?	; bytes per sector (02h = 512)
DPT_04h		db	?	; sectors per track
DPT_05h		db	?	; length of gap between sectors
DPT_06h		db	?	; data length
DPT_07h		db	?	; gap length when formatting
DPT_08h		db	?	; format filler byte (default F6h)
DPT_09h		db	?	; head settle time in milliseconds
DPT_0Ah		db	?	; motor start time in 1/8 seconds
DPT		ends

vars		struc
DataSectL	dw	?
DataSectH	dw	?
C_Track		dw	?
C_Sect		db	?
RootSectL	dw	?
RootSectH	dw	?
vars		ends

boot_begin:
		cli
		xor	ax, ax
		mov	ss, ax
		mov	sp, omem
		push	ss
		pop	es
		mov	bx, 1Eh * 4
		lds	si, ss:[bx]
		push	ds
		push	si
		push	ss
		push	bx
		mov	di, offset boot_begin - off
		mov	cx, SIZE DPT
		cld
		rep	movsb
		push	es
		pop	ds
		mov	byte ptr [di-2], 0Fh	; DPT_09h & DPT_0Ah
		mov	cx, word ptr ds:[Sectors - off]
		mov	[di-7], cl	; DPT_04h
		mov	[bx+2], ax	; segment
		mov	[bx], offset boot_begin - off
		sti
		int	13h		; disk - reset
		jb	wait_key
		xor	ax, ax
		cmp	word ptr ds:[TotSecs - off], ax
		jz	loc_0_184
		mov	cx, word ptr ds:[TotSecs - off]
		mov	word ptr ds:[LogSectL - off], cx
loc_0_184:	mov	al, byte ptr ds:[FatCnt - off]
		mul	word ptr ds:[FatSize - off]
		add	ax, word ptr ds:[HidSectL - off]
		adc	dx, word ptr ds:[HidSectH - off]
		add	ax, word ptr ds:[ResSecs - off]
		adc	dx, 0
		mov	word ptr ds:[RootSectL + offd], ax
		mov	word ptr ds:[RootSectH + offd], dx
		mov	word ptr ds:[DataSectL + offd], ax
		mov	word ptr ds:[DataSectH + offd], dx
		mov	ax, 20h		; 32 bytes each directory entry
		mul	word ptr ds:[RootSiz - off]
		mov	bx, word ptr ds:[SectSiz - off]
		add	ax, bx
		dec	ax
		div	bx
		add	word ptr ds:[DataSectL + offd], ax
		adc	word ptr ds:[DataSectH + offd], 0
		mov	bx, 500h
		mov	dx, word ptr ds:[RootSectH + offd]
		mov	ax, word ptr ds:[RootSectL + offd]
		call	comp_sct
		jb	wait_key
		mov	al, 1
		call	read_sct
		jb	wait_key
		mov	di, bx
		mov	cx, offset m_MsdosSys - m_IoSys
		mov	si, offset m_IoSys - off
		rep	cmpsb
		jnz	wait_key
		lea	di, [bx+20h]
		mov	cx, offset m_MsdosSys - m_IoSys
		rep	cmpsb
		jz	loc_0_205
wait_key:	mov	si, offset m_NonSystem - off
		call	pr_str
		xor	ax, ax
		int	16h		; keyboard - read char
		pop	si
		pop	ds
		pop	[si]
		pop	[si+2]
		int	19h		; disk boot
loc_0_200:	pop	ax
		pop	ax
		pop	ax
		jmp	short wait_key
loc_0_205:	mov	ax, [bx+1Ah]	; first cluster
		dec	ax
		dec	ax
		mov	bl, byte ptr ds:[ClustSiz - off]
		xor	bh, bh
		mul	bx
		add	ax, word ptr ds:[DataSectL + offd]
		adc	dx, word ptr ds:[DataSectH + offd]
		mov	bx, 700h
		mov	cx, 3
loc_0_220:	push	ax
		push	dx
		push	cx
		call	comp_sct
		jb	loc_0_200
		mov	al, 1
		call	read_sct
		pop	cx
		pop	dx
		pop	ax
		jb	wait_key
		add	ax, 1
		adc	dx, 0
		add	bx, word ptr ds:[SectSiz - off]
		loop	loc_0_220
		mov	ch, byte ptr ds:[Media - off]
		mov	dl, byte ptr ds:[B_Drive - off]
		mov	bx, word ptr ds:[DataSectL + offd]
		mov	ax, word ptr ds:[DataSectH + offd]
;		jmp	far ptr 70h:0
		db	0eah
		dd	700000h

;		S u b r o u t i n e

pr_str		proc	near
		lodsb
		or	al, al
		jz	n_ret
		mov	ah, 0Eh			; - video - write character
		mov	bx, 7
		int	10h
		jmp	short pr_str
pr_str		endp

;		S u b r o u t i n e

comp_sct	proc	near
		cmp	dx, word ptr ds:[Sectors - off]
		jnb	e_ret
		div	word ptr ds:[Sectors - off]
		inc	dl
		mov	byte ptr ds:[C_Sect + offd], dl
		xor	dx, dx
		div	word ptr ds:[HeadCnt - off]
		mov	byte ptr ds:[B_Head - off], dl
		mov	word ptr ds:[C_Track + offd], ax
		clc
		retn
comp_sct	endp

e_ret:
		stc
n_ret:
		retn

;		S u b r o u t i n e

read_sct	proc	near
		mov	ah, 2
		mov	dx, word ptr ds:[C_Track + offd]
		mov	cl, 6
		shl	dh, cl
		or	dh, byte ptr ds:[C_Sect + offd]
		mov	cx, dx
		xchg	ch, cl
		mov	dl, byte ptr ds:[B_Drive - off]
		mov	dh, byte ptr ds:[B_Head - off]
		int	13h		; disk - read sectors
		retn
read_sct	endp

m_NonSystem	db	0Dh,0Ah
		db	'Non-System disk or disk error',0Dh,0Ah
		db	'Replace and press any key when ready'
		db	0Dh,0Ah,0
m_IoSys		db	'IO      SYS'
m_MsdosSys	db	'MSDOS   SYS'
		dw	0
		dw	0aa55h
label		boot_end

p_hex		proc	near
		push	ax
		mov	cl, 4
		shr	al, cl
		call	p_half
		pop	ax
		and	al, 0fh
p_half:		add	al, 90h		 ; external entry
		daa
		adc	al, 40h
		daa
pr_ch:		mov	ah, 2		 ; external entry
		mov	dl, al
		int	21h		; fnct 02h display char dl
		ret
p_hex		endp

p_dhex		proc	near
		push	ax
		mov	al, ah
		call	p_hex
		pop	ax
		call	p_hex
		ret
p_dhex		endp


;====================================================
;   Find the original INT 13 (in ROM)
;====================================================

		assume	ds:_TEXT

new_int1	proc	far
		push	bp
		mov	bp, sp
		push	es ds ax
		mov	ax, cs
		mov	ds, ax
		cmp	find_flag, 1
		jz	quit_exit
		cmp	[bp+4], ax
		jz	end_of_13_?
		cmp	[bp+4], 0f000h
		jnz	norm_exit
		mov	ax, [bp+2]   ; IP for ROM address
		mov	word ptr orig13, ax
		mov	ax, [bp+4]   ; CS for ROM address
		mov	word ptr orig13+2, ax
		mov	find_flag, 1
		jmp	quit_exit
end_of_13_?:	cmp	word ptr [bp+2], offset end_int13
		jb	norm_exit
quit_exit:	and	[bp+6], NOT 100h ; reset the TRAP flag
norm_exit:	pop	ax ds es bp
		iret
new_int1	endp

find_flag	db	0
old_int1	dd	?
orig13		dd	0

		PUBLIC	true13
true13		proc	C
		push	es ds si di
		mov	cs:find_flag, 0
		xor	ax, ax
		mov	ds, ax
		push	cs
		pop	es
		lea	di, old_int1
		mov	si, 4*1
		cli
		mov	ax, offset new_int1
		xchg	ax, ds:[si]
		stosw
		mov	ax, cs
		xchg	ax, ds:[si+2]
		stosw
		lea	di, orig13
		mov	si, 4*13h
		movsw
		movsw
		sti
		pushf
		pop	ax
		or	ax, 100h	      ; set the TRAP flag
		push	ax
		popf
		mov	ah, 1
		pushf
		call	dword ptr cs:orig13
end_int13:	push	cs
		pop	ds
		xor	ax, ax
		mov	es, ax
		cli
		mov	ax, word ptr old_int1
		mov	es:[4*1], ax
		mov	ax, word ptr old_int1+2
		mov	es:[4*1+2], ax
		sti
		mov	dx, word ptr orig13+2
		mov	ax, word ptr orig13
		pop	di si ds es
		ret
true13		endp

		PUBLIC save_video_mode
save_video_mode PROC C
		mov	ah, 0fh
		int	10h		; querry video mode
		and	al, 7fh
		mov	video_mode, al
		mov	video_page, bh
		cmp	al, 3
		jnz	@@noswap
		push	ds si di
		mov	ax, DGROUP
		mov	es, ax
		mov	ax, 0b800h
		mov	ds, ax
		mov	bl, 0
		shl	bx, 4
		mov	si, bx
		mov	cx, 80*25
		lea	di, video_data
		rep	movsw
		pop	di si ds
		mov	ah, 3
		int	10h		; querry cursor shape
		mov	cursor_shape, cx
		mov	cursor_pos, dx
@@noswap:	ret
save_video_mode endp

		PUBLIC	set_hi_text_mode
set_hi_text_mode PROC	C		; cx = 0/1 - low/hi
		push	es bp dx
IFDEF	STRIP
		mov	ax, 3
		int	10h
		mov	ax, 500h	; display page 0
		int	10h
ENDIF
		jcxz	@@rows
		mov	ax, 1112h
		mov	bl, 0
		int	10h		; set 8x8 font
@@rows:		mov	ax, 1130h
		mov	bh, 0
		int	10h		; font info
		mov	al, dl		; last row
		cbw
		pop	dx bp es
		ret
set_hi_text_mode endp

		PUBLIC restore_video_mode
restore_video_mode PROC C
		mov	ah, 0
		mov	al, video_mode
		int	10h		; restore video mode
		cmp	byte ptr video_mode, 3
		jnz	@@noswap
		push	si di
		mov	ax, 0b800h
		mov	es, ax
		mov	bh, video_page
		mov	bl, 0
		shl	bx, 4
		mov	di, bx
		mov	cx, 80*25
		lea	si, video_data
		rep	movsw
		pop	di si
		mov	ah, 5		; display page 0
		mov	al, video_page
		int	10h
		mov	ah, 1
		mov	cx, cursor_shape
		int	10h		; restore cursor shape
		mov	ah, 2
		mov	dx, cursor_pos
		int	10h		; restore cursor pos
@@noswap:	ret
restore_video_mode endp

		PUBLIC hide_cursor
hide_cursor	PROC C
		mov	ah, 3
		int	10h
		mov	ah, 1
		mov	cx, 2000h
		int	10h
		ret
hide_cursor	endp

		PUBLIC	clear_screen
clear_screen	PROC	C
		mov	ax, 80
		mul	cx
		mov	cx, ax
		mov	ax, 0b800h
		mov	es, ax
		mov	ax, 0720h
		xor	di, di
		rep	stosw
		ret
clear_screen	endp

		PUBLIC	interleave_one
interleave_one	PROC	C
		push	bx
		mov	byte ptr es:[bx], 0	; first sector
		mov	si, bx
		add	si, 4000h		; total size 0x4000
@@f_next:	inc	bx
		mov	byte ptr src_shift, 0
@@src_again:	mov	al, 0a1h
		mov	cx, 400h
		mov	di, bx
@@kp_src:	repnz	scasb
		jcxz	@@shift
		cmp	byte ptr es:[di], 0a1h
		jnz	@@kp_src
		cmp	byte ptr es:[di+1], 0a1h
		jnz	@@kp_src
		cmp	byte ptr es:[di+2], 0feh
		jnz	@@kp_src
		add	di, 5
		mov	cx, si
		sub	cx, di
		jc	@@compute
@@restr:	push	bx
@@lpp:		mov	al, es:[di]
		mov	es:[bx], al
		inc	di
		inc	bx
		loop	@@lpp
		mov	si, bx
		pop	bx
		jmp	@@f_next
@@shift:	inc	src_shift
		cmp	byte ptr src_shift, 8
		jz	@@not_found
		mov	di, si
		sub	di, bx
@@shift_byte:	dec	di
		rcl	byte ptr es:[bx + di], 1
		jz	@@src_again
		jmp	@@shift_byte
@@not_found:	mov	cx, si
		mov	di, bx
		add	di, 280h
		sub	cx, di
		jc	@@compute
		mov	byte ptr es:[di], 00	; not found
		jmp	@@restr
@@compute:	pop	si
		mov	di, si
		mov	al, 0			; max
@@adv:		cmp	al, es:[di]
		jnc	@@lower
		mov	al, es:[di]
@@lower:	inc	di
		cmp	di, bx
		jc	@@adv
		cbw				; max sector
		mov	cx, ax
		mov	bx, si
		add	bx, cx
		mov	ax, 1
@@nxt_BI:	cmp	al, es:[si]
		jnz	@@not_expected
		inc	ah
@@not_expected: inc	al
		inc	si
		cmp	si, bx
		jc	@@nxt_BI
		shr	cl, 2
		cmp	ah, cl
		mov	ax, 0
		jb	@@fail
		inc	ax
@@fail:		ret
interleave_one	endp
;			D-1	D	cod
;			-------------------
;			 X	1	01
;			 1	0	00
;			 0	0	10
		PUBLIC	re_align
re_align	PROC	C
		mov	byte ptr src_shift, 0
@@src_again:	mov	al, 0a1h
		mov	cx, 0200h
		mov	di, bx
@@kp_src:	repnz	scasb
		jcxz	@@shift
		jmp	@@verify_marks
@@shift:	inc	src_shift
		cmp	byte ptr src_shift, 8
		jz	@@not_found
		mov	di, 4000h
		sub	di, bx
		and	di, 3fffh
@@shift_byte:	dec	di
		rcl	byte ptr es:[bx + di], 1
		jz	@@src_again
		jmp	@@shift_byte
@@not_found:	mov	di, bx
		add	di, 80h		; discard aprox 128 extra bytes
		mov	al, 0		; insuccess
		jmp	@@shift_left
@@verify_marks: cmp	byte ptr es:[di], 0a1h
		jnz	@@kp_src
		cmp	byte ptr es:[di+1], 0a1h
		jnz	@@kp_src
		cmp	byte ptr es:[di+2], 0fbh
		jnz	@@kp_src
		add	di, 3
		mov	al, 1		; success
@@shift_left:	mov	cx, 4000h
		sub	cx, di
		and	cx, 3fffh
@@lpp:		mov	ah, es:[di]
		mov	es:[bx], ah
		inc	di
		inc	bx
		loop	@@lpp
		cbw
		ret
re_align	endp

		PUBLIC	med_byte
med_byte	PROC   C
		; es:si = pointer di = count
		mov	ch, 1
		xor	dx, dx
@@nx_bit:	mov	bx, di		; count
		xor	ax, ax
@@mo:		dec	bx
		mov	cl, es:[si+bx]
		and	cl, ch
		add	al, cl
		jnc	@@nc
		inc	ah
@@nc:		test	bx, bx
		jnz	@@mo
		mov	cl, ch
@@msh:		shr	cl, 1
		jc	@@nosh
		shr	ax, 1
		jmp	@@msh
@@nosh:		mov	bx, di		; count
		shr	bx, 1		; half count
		add	ax, bx
		mov	bx, di		; count
		div	bl
		and	al, al
		jz	@@bit0
		or	dl, ch		; final value
@@bit0:		shl	ch, 1
		jnc	@@nx_bit
		mov	bx, di		; count
@@mo_cmp:	dec	bx
		cmp	dl, es:[si+bx]
		jz	@@equal
		mov	dh, 1		; "different" signal
		jmp	@@fin
@@equal:	test	bx, bx
		jnz	@@mo_cmp
@@fin:		ret
med_byte	endp

		end
