/* ======== */
/* revive.h */
/* ======== */

#define RESET	    0
#define STATUS	    1
#define READ	    2
#define WRITE	    3
#define VERIFY	    4
#define FORMAT	    5
#define READ_TRACK  0x0a
#define SEEK_CYL    0x0c
#define READ_ID	    0x10
#define SET_MEDIA   0x18

#define NONE	    0
#define ERROR	    0xf000
#define RECOVER	    0x1000
#define RETRY	    0x0100
#define ALIGN	    0x0200
#define CRC	    0x0300

#define ESC	    0x11b
#define UP_ARROW    0x4800
#define DOWN_ARROW  0x5000
#define LEFT_ARROW  0x4b00
#define RIGHT_ARROW 0x4d00
#define HOME_KEY    0x4700
#define END_KEY	    0x4f00
#define ENTER	    0x1c0d

#define hib(x)	    (*((unsigned char *)&(x) + 1))
#define SECT_STATUS(trk, hd, sect) \
  *(sect_status + (((trk * Boot->HeadCnt) + hd) * Boot->Sectors + sect))

#define BAR_LINE    3
#define BAR_COLOR   2
#define START_LINE  7
#define END_LINE    23
#define S_LINES	    (END_LINE - START_LINE - 3)
#define S_COLS	    3

#define MAX_SECTORS 80 * 2 * 18

typedef unsigned char byte;
typedef unsigned int word;

typedef struct
{
  int		abs_sect;
  int		track;
  int		head;
  int		sect;
  int		error_type;
}	      sector_s;

struct Boot_t
{
  word		SectSiz;
  byte		ClustSiz;
  word		ResSecs;
  byte		FatCnt;
  word		RootSiz;
  word		TotSecs;
  byte		Media;
  word		FatSize;
  word		Sectors;
  word		HeadCnt;
  word		HidSectL;
  word		HidSectH;
  word		LogSectL;
  word		LogSectH;
  byte		B_Drive;
  byte		B_Head;
};

extern void  *true13( void );
#pragma aux   true13 "_*" value [AX DX];
extern void   save_video_mode( void );
#pragma aux   save_video_mode "_*";
extern void   restore_video_mode( void );
#pragma aux   restore_video_mode "_*";
extern void   clear_screen( int );
#pragma aux   clear_screen "_*" parm [CX];
extern void   hide_cursor( void );
#pragma aux   hide_cursor "_*";
extern int    med_byte( byte *, int );
#pragma aux   med_byte "_*" parm [ES SI] [DI] value [DX] modify [AX BX CX SI];
extern int    re_align( char * );
#pragma aux   re_align "_*" parm [ES BX] value [AX] modify [AX BX CX DI];
extern int    interleave_one( char * );
#pragma aux   interleave_one "_*" parm [ES BX] modify [AX BX CX SI DI];
extern int    set_hi_text_mode( int );
#pragma aux   set_hi_text_mode "_*" parm [CX] value [AX];
#pragma aux   boot_start "_*";
extern void   boot_start(  );
#pragma aux   hook_int_0E "_*";
extern void   hook_int_0E(  );
#pragma aux   restore_int_0E "_*";
extern void   restore_int_0E(  );

/* output.c 08/04/98 04.45.50 */
void	      cput( int, int, int, char, int,... );
int	      sput( int, int, char * );
int	      csput( int, int, char * );
int	      esput( int, int, char * );
void	      box( int, int, int, int, char *, int, char, int );
void	      show_tracks( void );
void	      mark_active( int, int, int );
int	      revers( int );
void	      hilite( int, int, int, int ( * ) ( int ) );

/* verbose.c 06/04/98 04.22.50 */
void	      show_tracks( void );
void	      mark_active( int, int, int );
void	      swap_screen( int );
void	      toggle_map( void );
void	      verbose( int, int, int, char, char * );

/* recover.c 08/04/98 01.38.22 */
int	      dos_recover( void );
int	      new_boot_fat( byte *, int );

/* int13.c 08/04/98 01.38.22 */
int	      int13( int,... );

/* revalg.c 03/04/98 21.34.30 */
int	      revive( void );
void	      toggle_map( void );

/* revive.c 03/04/98 21.35.48 */
int	      int13( int,... );

extern struct Boot_t *Boot;
extern word  *scr_zone;
extern int    current_ch;
extern int    otrk;
extern byte   Drive;
extern int    Tracks;
extern byte  *fat;
extern int    fresh_boot;
extern word  *sect_status;
extern word   crc_table[];
extern char  *line, *fmtbuf;
extern char  *trkbuf;
extern int    intlv_one;
extern int    screen_poz;
extern int    last_line;
extern int    map_active;
extern sector_s *SD[];
extern int    file_secs;
extern FILE  *sb;
