#include <stdio.h>
#include <stdarg.h>
#include <conio.h>
#include <dos.h>
#include <bios.h>
#include <string.h>
#include <malloc.h>

#include "revive.h"

void
show_tracks( void )
{
  int		i;
  char		track[4];

  esput( 75, BAR_LINE + 2,
	 "%c0f  %c02recovered track  %c06: "
	 "%c0c  %c04permanent error %c0B" );
  cput( 5, 1, BAR_LINE, '', BAR_COLOR, 80 );
  for ( i = 0; i < 80; i += 5 )
  {
    cput( 4, i + 1, BAR_LINE, '', BAR_COLOR );
    sprintf( track, "%d", i );
    sput( i + 1, BAR_LINE + 1, track );
  }
  cput( 4, 1, BAR_LINE, '', BAR_COLOR );
  cput( 4, 80, BAR_LINE, '', BAR_COLOR );
}

void
mark_active( int trk, int head, int type )
{
  const int	OFF = ( BAR_LINE - 1 ) * 160;

  type &= 0xff00;
  switch ( type )
  {
    case ERROR:
      if ( ( current_ch & 0xff ) == 0x19 && head )
      {
	current_ch = 0x0c12;
	break;
      }
      current_ch = 0x0c19 - head;
      break;
    case RECOVER:
      if ( ( current_ch & 0xff ) == 0x19 && head )
      {
	current_ch = ( current_ch & 0xff00 ) | 0x12;
	break;
      }
      current_ch = 0x0f19 - head;
      break;
    case NONE:
      *( word * ) MK_FP( 0xb800, OFF + 2 * otrk ) = current_ch;
      current_ch = *( word * ) MK_FP( 0xb800, OFF + 2 * trk );
      *( word * ) MK_FP( 0xb800, OFF + 2 * trk ) = 0x0e19 - head;
      otrk = trk;
      break;
  }
}

void
swap_screen( int mode )
{
  int		i, j;
  word	       *s;
  word	       *d;

  if ( scr_zone == NULL )
    scr_zone = ( word * ) malloc( 25 * 80 * sizeof( word ) );
  if ( scr_zone == NULL )
    return;
  if ( mode )
  {
    if ( scr_zone != NULL )
    {
      d = scr_zone;
      s = ( word * ) MK_FP( 0xb800, 0 );
      for ( i = 0; i < 25; i++ )
	for ( j = 0; j < 80; j++ )
	  *d++ = *( s + i * 80 + j );
    }
    last_line = set_hi_text_mode( 1 );
    hide_cursor(  );
    if ( last_line < 49 )
    {
      csput( 40, END_LINE, "%c4f Sorry your video card does not support "
	     "VGA 50 lines mode " );
    }
    if ( scr_zone != NULL )
    {
      d = scr_zone;
      s = ( word * ) MK_FP( 0xb800, 0 );
      for ( i = 0; i < BAR_LINE + 2; i++ )
	for ( j = 0; j < 80; j++ )
	  *( s + i * 80 + j ) = *d++;
    }
  }
  else
  {
    last_line = set_hi_text_mode( 0 );
    hide_cursor(  );
    if ( scr_zone != NULL )
    {
      d = scr_zone;
      s = ( word * ) MK_FP( 0xb800, 0 );
      for ( i = 0; i < 25; i++ )
	for ( j = 0; j < 80; j++ )
	  *( s + i * 80 + j ) = *d++;
    }
  }
}

void
toggle_map( void )
{
  int		i, j, k, l[2];
  char		c, col;
  char	       *help_tbl[] = {
    "%c20.%c02 - Normal block",
    "%c20%c02 - Formatted block",
    "%cafE%c02 - Unrecovered error",
    "%c20_%c02 - Retry recovered",
    "%c20a%c02 - Alignament recovered",
    "%c20c%c02 - CRC recovered"};

  if ( map_active )
  {
    swap_screen( 0 );
  }
  else
  {
    swap_screen( 1 );
    if ( last_line >= 49 )
    {
      cput( 5, 1, START_LINE, '', 0x03, 80 );
      csput( 40, START_LINE, "%c0f Head 0 " );
      cput( 5, 1, START_LINE + Boot->Sectors + 1, '', 0x03, 80 );
      csput( 40, START_LINE + Boot->Sectors + 1, "%c0f Head 1 " );
      cput( 5, 1, START_LINE + 2 * ( Boot->Sectors + 1 ), '', 0x03, 80 );

      k = START_LINE + 2 * ( Boot->Sectors + 1 ) + 1;
      j = 5;
      for ( i = 0; i < sizeof( help_tbl ) / sizeof( char * ); i++ )
      {
	l[i & 1] = sput( j, k + ( i & 1 ), help_tbl[i] );
	if ( i & 1 )
	  j += 4 + ( l[0] > l[1] ? l[0] : l[1] );
      }
      for ( i = 0; i < Tracks; i++ )
	for ( j = 0; j < Boot->Sectors; j++ )
	  for ( k = 0; k < Boot->HeadCnt; k++ )
	  {
	    col = 0x20;
	    switch ( SECT_STATUS( i, k, j ) & 0xff00 )
	    {
	      case ERROR:
		c = 'E';
		col = 0xaf;
		break;
	      case RECOVER | ALIGN:
		c = 'a';
		break;
	      case RECOVER | CRC:
		c = 'c';
		break;
	      case RECOVER | RETRY:
		c = '_';
		break;
	      case FORMAT << 8:
		c = '';
		break;
	      case NONE:
		c = '.';
		break;
	      default:
		c = '.';
		col = 0x06;
		break;
	    }
	    cput( 4, i + 1, START_LINE + k * ( Boot->Sectors + 1 ) + 1 + j, c, col );
	  }
    }
  }
  map_active ^= 1;
}

void
verbose( int track, int head, int sect, char c, char *string )
{
  int		x, y;

  x = 3 + ( 76 / S_COLS ) * ( screen_poz / S_LINES );
  y = START_LINE + 1 + screen_poz % S_LINES;
  sprintf( line, "%%c03%d/%d/%d", track, head, sect );
  sput( x, y, line );
  cput( 4, x + 9, y, c, c == 'E' ? 0x0c : 0x0f );
  sprintf( line, "%%c02%s", string );
  sput( x + 11, y, line );
  screen_poz++;
  screen_poz %= S_LINES * S_COLS;
  x = 3 + ( 76 / S_COLS ) * ( screen_poz / S_LINES );
  y = START_LINE + 1 + screen_poz % S_LINES;
  cput( 5, x, y, ' ', 0, 76 / S_COLS );
}
